/* Copyright (C) 2014 TU Dortmund
 * This file is part of LearnLib, http://www.learnlib.de/.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package de.learnlib.algorithms.features.observationtable.writer;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;

import javax.annotation.ParametersAreNonnullByDefault;
import javax.annotation.WillNotClose;

import de.learnlib.algorithms.features.observationtable.ObservationTable;

@ParametersAreNonnullByDefault
public interface ObservationTableWriter<I, D> {
	public void write(ObservationTable<? extends I,? extends D> table, @WillNotClose Appendable out) throws IOException;
	public void write(ObservationTable<? extends I,? extends D> table, @WillNotClose PrintStream out);
	public void write(ObservationTable<? extends I,? extends D> table, @WillNotClose StringBuilder out);
	public void write(ObservationTable<? extends I,? extends D> table, File file) throws IOException;
}
